Attribute VB_Name = "Module3"
Option Explicit

Function indextobit(color As Long, i As Integer) As Byte
If i = 1 Or i = 0 Then ' black
    color = QBColor(0)
    indextobit = 3
ElseIf i = 2 Then ' dark gray
    color = QBColor(8)
    indextobit = 2
ElseIf i = 3 Then ' light gray
    color = QBColor(7)
    indextobit = 1
Else ' white
    color = QBColor(15)
    indextobit = 0
End If
End Function
' use a sorted colortable (4 entries) and set color accordingly
Function longtobit(color As Long, colortable() As Integer) As Byte
Dim i As Integer
For i = 1 To 4
    If colortable(i) = color Then
        longtobit = indextobit(color, i)
        Exit Function
    End If
Next i
' not found in color table
longtobit = indextobit(color, (longtogray(color) / 64)) ' convert gray to 1-4
End Function
Function longtogray(color As Long) As Integer
Dim red, green, blue
red = (color / &H10000) And &HFF
green = (color / &H100) And &HFF
blue = color And &HFF
longtogray = ((red + blue + green) / 3)
End Function
Sub sortcolortable(colortable() As Integer)
Dim i As Integer, j As Integer
For i = 1 To 4
    For j = i + 1 To 4
        If colortable(i) > colortable(j) Then
            Dim swap As Integer
            swap = colortable(i)
            colortable(i) = colortable(j)
            colortable(j) = swap
        End If
    Next j
Next i
End Sub
' analyze image
' return true if 4 colors and colors in colors()
' else return false and min/max
Function analyze(Picture1 As PictureBox, min As Integer, max As Integer, colortable() As Integer) As Boolean
Dim i As Integer
Dim x As Integer, y As Integer, col As Long
Dim countcolors As Integer
countcolors = 0
analyze = True
min = 1000
max = -1
For y = 0 To 159
    For x = 0 To 159
        col = Picture1.Point(x, y)
        If col = -1 Then col = &HFFFFFF ' outside = white
        col = longtogray(col) ' convert to grayscale
        If col > max Then max = col
        If col < min Then min = col
        For i = 1 To countcolors
            If colortable(i) = col Then GoTo nextx
        Next i
        If countcolors < 4 Then
            countcolors = countcolors + 1
            colortable(countcolors) = col
        Else
            analyze = False
        End If
nextx:
    Next x
Next y
End Function

Public Sub convert(Picture1 As PictureBox, filename As String)
Dim x As Integer, y As Integer, xx As Integer, col As Long
Dim colortable(1 To 4) As Integer ' simple lookup table
Dim min As Integer, max As Integer
Dim fourcolors As Boolean

Dim b As Byte, bits As Byte
On Error GoTo errhandler
Form1.MousePointer = vbHourglass
Open filename For Binary Access Write As #1
initheader
Put #1, , bheader() ' write pdb header
' now read the picture
Picture1.ScaleMode = vbPixels
Picture1.Refresh

' analyze picture
fourcolors = analyze(Picture1, min, max, colortable())
If fourcolors Then sortcolortable colortable()

' loop over all pixels
' slow :-(
For y = 0 To 159
    For x = 0 To 159 Step 4 ' 4 pixels per byte
        b = 0
        For xx = x To x + 3
            b = b + b
            b = b + b ' shift 2 bits left
           
            col = Picture1.Point(xx, y)
            If col = -1 Then col = &HFFFFFF ' outside picture = white
            col = longtogray(col)
            If fourcolors Then
                b = b Or longtobit(col, colortable)
                Picture1.PSet (xx, y), col
            Else
                b = b Or indextobit(col, ((col - min) / ((max - min) / 4))) ' convert gray to 1-4
                Picture1.PSet (xx, y), col
            End If
        Next xx
        Put #1, , b
    Next x
Next y
Close #1
Form1.MousePointer = vbDefault
Exit Sub
errhandler:
MsgBox "Error!"
Form1.MousePointer = vbDefault
End Sub
