#!/usr/local/bin/perl -w

# Takes a 160x160 *ascii* PGM file with colormap (0) (85) (170) (255)
# and converts it to "sweetheart" format.  --Paul Close, 9/8/97.

$file = $ARGV[0];
open(FILE, $file) || die "Can't open $file: $!\n";

open(OUT, ">out.pdb") || die "Can't open out.pdb: $!\n";
# write .pdb header
syswrite(OUT, pack("H32", "537765657468656172744442000000f0"), 16);
syswrite(OUT, pack("H32", "00000000c47e68000a000000f2050000"), 16);
syswrite(OUT, pack("H32", "0008000034082f6e34082f6e00000000"), 16);
syswrite(OUT, pack("H32", "00000004000000000000000044617461"), 16);
syswrite(OUT, pack("H32", "53687274000000000000000000010000"), 16);
syswrite(OUT, pack("H16", "0058400dc0006800"), 8);

$_ = scalar(<FILE>);
if ($_ ne "P2\n") {
    die "$file not ascii PGM format\n";
}
do {
    $_ = scalar(<FILE>);
} while ($_ =~ /^#/);
if ($_ ne "160 160\n") {
    die "$file not 160x160\n";
}
do {
    $_ = scalar(<FILE>);
} while ($_ =~ /^#/);
if ($_ ne "255\n") {
    die "$file not 255\n";
}

# Iterate through each pixel value and pack into a 2-bit representation

$byte = 0;
$count = 0;
while (<FILE>) {
    foreach $i (split) {
	if ($i eq "0") {
	    $byte = ($byte << 2) | 3;
	} elsif ($i eq "85") {
	    $byte = ($byte << 2) | 2;
	} elsif ($i eq "170") {
	    $byte = ($byte << 2) | 1;
	} elsif ($i eq "255") {
	    $byte = ($byte << 2) | 0;
	} else {
	    die "invalid code \"$i\"\n";
	}
	$count++;
	if ($count == 4) {
	    syswrite(OUT, pack("c",$byte), 1);
	    $byte = 0;
	    $count = 0;
	}
    }
}
close(FILE);
close(OUT);

